world = class("world")

function world:initialize(map)
	self.path = map
	self.map = require("assets/maps/"..map)

	for i,v in pairs(self.map.layers) do
		if v.name == "overworld" then 
			self.overworld = v
		end 
	end 
	if self.overworld == nil then
		self.overworld = self.map.layers[1]
	end

	self.overworld = self:readData(self.overworld.data, self.overworld)

	self.batch = love.graphics.newSpriteBatch(terrainSheet.image, 1000*1000)

end 

function world:update(dt)
	for i=round(player.y/16, 0) - 50, round(player.y/16, 0) + 50 do
		for j= round(player.x/16, 0) - 50,round(player.x/16, 0) + 50 do
			self.overworld.map[i][j]:update(dt)
		end
	end
end 

function world:draw()
	renderDistanceWidth = round(w/cam.scale / 16 /2, 0) + 1
	renderDistanceHeight = round(h/cam.scale / 16 /2, 0) + 1

	self.batch:clear()
	for i=round(player.y/16, 0) - renderDistanceHeight, round(player.y/16, 0) + renderDistanceHeight do
		for j= round(player.x/16, 0) - renderDistanceWidth, round(player.x/16, 0) + renderDistanceWidth do

			local tile = self.overworld.map[i][j]

			if tile.animated then
				self.batch:add(tile.animation:getFrameInfo(tile.x,tile.y,0,1,1,0,0,0,0))
			else
				self.batch:add(tile.image, tile.x, tile.y)
			end
		end
	end
	love.graphics.draw(self.batch)
end 

function world:readData(data, layer)
	layer.map = {}
	layer.heightMap = {}

	for i=1, layer.height do
		local row = {}
		local heightRow = {}
		for j=1, layer.width do
			local n = data[(i*layer.height +(j-1)-layer.width)+1]

			if n ~= 0 then  
				local image = n

				local x = j*16-1
				local y = i*16-1
				table.insert(row, tile:new(x, y, image))
				--Height map 
				local height = 10
				if n == 201 then 
					local height = 0
				end
				table.insert(heightRow, height)
			end
		end
		table.insert(layer.map, row)
		table.insert(layer.heightMap, heightRow)
	end

	return layer
end