anim8 = require("assets/scripts/libs/anim8")
camera = require("assets/hump/camera")
class = require("assets/scripts/libs/middleclass")

Player = require("assets/scripts/player")


require("assets/scripts/sheet")
require("assets/scripts/animations")
require("assets/scripts/tile")
require("assets/scripts/functions")
require("assets/scripts/world")

require("assets/scripts/ai/crab")

w = love.graphics.getWidth()
h = love.graphics.getHeight()

function love.load()
	loadingScreen("World 0%")

	player = player:new(550*16, 636*16) --550, 636
	cam = camera(player.x, player.y)
	cam.scale = 2.9

	world = world:new("demo")
end


function love.update(dt)
	player:update(dt)

	updateGlobalAnimations(dt)
	updateWater(dt)
	world:update()

	if love.keyboard.isDown("up") then
		zoom(1)
	elseif love.keyboard.isDown("down") then
		zoom(-1)
	end
end

function love.draw()
	cam:attach()
		world:draw()

		player:draw()
	cam:detach()
	
	love.graphics.setColor(255,255,255)
	love.graphics.print("FPS: "..love.timer.getFPS())
	love.graphics.print(player.x .."; ".. player.y,0, 15)
	love.graphics.print(cam.scale, 0, 30)
	love.graphics.print(w..", "..h, 0, 45)
	love.graphics.print(renderDistanceWidth*renderDistanceHeight, 0, 60)
end 

function love.wheelmoved(x, y) -- Scaling with mousewheel. Maybe move to player?
   zoom(y)
end

function love.keypressed(key)
	if key == "escape" then 
		love.event.quit()
	end 
end

function love.resize(width, height)
	w = width
	h = height
end

function loadingScreen(text)
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill", 0,0, w, h)
	love.graphics.setColor(255,255,255)
	love.graphics.print("Loading "..text.."",0, 10)
	love.graphics.present()
end